package com.unipi.talepis;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class Form1 extends JFrame{
    private JPanel panel1;
    private JTextField textField1;
    private JButton pressMeButton;
    private JLabel label1;
    private JButton goToForm2Button;
    private JButton serializeButton;
    private JButton deserializeButton;
    List<Student> students = new ArrayList<>();

    public Form1(){
        setTitle("My new GUI Form");
        setPreferredSize(new Dimension(500,400));
        setContentPane(panel1);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        pack();
        setLocationRelativeTo(null);//για να εμφανίζεται πάντα στο κέντρο της οθόνης
        setVisible(true);
        pressMeButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String s = textField1.getText();
                label1.setText(s);
            }
        });
        goToForm2Button.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                new Form2(textField1.getText());
            }
        });
        serializeButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                students.add(new Student(20,"Maria"));
                students.add(new Student(21,"George"));
                students.add(new Student(25,"Dimitris"));
                mySerialize(students,"students.ser");
            }
        });
        deserializeButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                List<Student> tempList = myDeserialize("students.ser");
                StringBuilder builder = new StringBuilder();
                for (Student s :
                        tempList) {
                    builder.append("Student:").append(s.name).append(",").append(s.age).append("\n");
                }
                JOptionPane.showMessageDialog(Form1.this,builder.toString());
            }
        });
    }
    static void mySerialize(List<Student> studentList, String fileName){
        try {
            FileOutputStream f = new FileOutputStream(fileName);
            ObjectOutputStream o = new ObjectOutputStream(f);
            o.writeObject(studentList);
            o.close();
            f.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    static List<Student> myDeserialize(String fileName){
        List<Student> students = new ArrayList<>();
        try {
            FileInputStream f = new FileInputStream(fileName);
            ObjectInputStream o = new ObjectInputStream(f);
            students = (List<Student>) o.readObject();
            o.close();
            f.close();
        } catch (IOException | ClassNotFoundException e) {
            e.printStackTrace();
        }
        return students;
    }
}

class Student implements Serializable {
    int age;
    String name;
    public Student(int age, String name) {
        this.age = age;
        this.name = name;
    }
}
